#        obj_explorer.txt
#  obj_explorer.txt     scripts/explorer

# ,    :

# binning 1                : ,  1,2,...    NxN
# waitbeforeexposure 10    :     
# timeexposure 30          :    
# numberexposure 2         :   
# iteration 2              :  .     
# waitbeforeserie 10       :      . 
# headingname noname_      :    ,        . 
# limitazimuthleft 24      :     (0 -, 90 - ,...)
# limitazimuthright 350    :    
# limithaltitudedown 5     :    
# limitaltitudeup 80       :    
# sunalt -12               :      
# moonalt 6                :      
# endpark yes              :       ? yes - , no - 
# autoguidephd yes         :       PHDGuide? yes - , no - 
# 
#  :
# 21 44 +74 44 1 30 5 name_  -   (  ),  (  )
#  :
#  - 1 (11), 2 (22)  ..
#    
#  
#   
#        ,     .    4  ,   . 
# 
#     * ( * 21 44 +74 44),    ,     
#     % ( % 21 44 +74 44),    ,   (     +     )
# 
# 
################################################################################

# Ici commence le script

global audace

source [file join $audace(rep_scripts) explorer explorer.cap]

# Lignes en-t?te
set numligne_binning 1
set numligne_waitbeforeexposure 2
set numligne_timeexposure 3
set numligne_numberexposure 4
set numligne_iteration 5
set numligne_waitbeforeserie 6
set numligne_headingname 7
set numligne_limitazimuthleft 8
set numligne_limitazimuthright 9
set numligne_limitaltitudedown 10
set numligne_limitaltitudeup 11
set numligne_sunalt 12
set numligne_moonalt 13
set numligne_endpark 14
set numligne_autoguidephd 15

# Premi?re ligne contenant des coordonn?es
set numligne_coord1 16

set entete_ligne_console "# "


#--------------------------------------------------------------------------#
#  Message                                                                 #
#--------------------------------------------------------------------------#
#  Permet l'affichage de messages format?s dans la Console                 #
#                                                                          #
#  Param?tres d'entr?e :                                                   #
#  - niveau :                                                              #
#     console : affichage dans la Console                                  #
#     test : mode debug                                                    #
#                                                                          #
# Param?tres de sortie : Aucun                                             #
#                                                                          #
# Algorithme :                                                             #
#  si niveau Console, affichage, puis attente que toutes les t?ches soient #
#  ?x?cut?es                                                               #
#--------------------------------------------------------------------------#
proc Message {niveau args} {
   switch -exact -- $niveau {
      console {
         ::console::disp [eval [concat {format} $args]]
         update idletasks
      }
   }
}
#---Fin de Message---------------------------------------------------------#

Message console "${entete_ligne_console}$caption(explorer,start_explorer)\n"

# On lit le fichier obj_explorer.txt

set input [ open "[ file join $audace(rep_scripts) explorer obj_explorer.txt ]" r ]
set contents [split [read $input] \n]
close $input

# Lecture des param?tres d'acquisition (les premi?res lignes du fichier)

set numligne 0
foreach obj $contents {
   set numligne [expr $numligne+1]

   # binning
   if {$numligne==$numligne_binning} {
      set binningdef [lindex $obj 1]
      Message console "${entete_ligne_console}$caption(explorer,binning) : ${binningdef}x${binningdef}\n"
   }

   # waitbeforeexposure
   if {$numligne==$numligne_waitbeforeexposure} {
      set waitbeforeexposuredef [lindex $obj 1]
      Message console "${entete_ligne_console}$caption(explorer,wait_before_exposure) : ${waitbeforeexposuredef} $caption(explorer,seconds)\n"
   }

   # timeexposure
   if {$numligne==$numligne_timeexposure} {
      set timeexposuredef [lindex $obj 1]
      Message console "${entete_ligne_console}$caption(explorer,time_exposure) : ${timeexposuredef} $caption(explorer,seconds)\n"
   }

   # numberexposure
   if {$numligne==$numligne_numberexposure} {
      set numberexposuredef [lindex $obj 1]
      Message console "${entete_ligne_console}$caption(explorer,number_exposures) : ${numberexposuredef}\n"
   }

   # iteration
   if {$numligne==$numligne_iteration} {
      set iterationdef [lindex $obj 1]
      Message console "${entete_ligne_console}$caption(explorer,iteration) : ${iterationdef}\n"
   }

   # waitbeforeserie
   if {$numligne==$numligne_waitbeforeserie} {
      set waitbeforeseriedef [lindex $obj 1]
      Message console "${entete_ligne_console}$caption(explorer,wait_before_serie) : ${waitbeforeseriedef} $caption(explorer,seconds)\n"
   }

   # headingname
   if {$numligne==$numligne_headingname} {
      set headingnamedef [lindex $obj 1]
      Message console "${entete_ligne_console}$caption(explorer,heading_name) : '${headingnamedef}'\n"
   }

   # limitazimuthleftdef 
   if {$numligne==$numligne_limitazimuthleft} {
      set limitazimuthleftdef [lindex $obj 1]
      Message console "${entete_ligne_console}$caption(explorer,limaz1) : '${limitazimuthleftdef}'\n"
   }

   # limitazimuthright
   if {$numligne==$numligne_limitazimuthright} {
      set limitazimuthrightdef [lindex $obj 1]
      Message console "${entete_ligne_console}$caption(explorer,limaz2) : '${limitazimuthrightdef}'\n"
   }

   # limitaltitudedown
   if {$numligne==$numligne_limitaltitudedown} {
      set limitaltitudedowndef [lindex $obj 1]
      Message console "${entete_ligne_console}$caption(explorer,limalt1) : '${limitaltitudedowndef}'\n"
   }

   # limitaltitudeup
   if {$numligne==$numligne_limitaltitudeup} {
      set limitaltitudeupdef [lindex $obj 1]
      Message console "${entete_ligne_console}$caption(explorer,limalt2) : '${limitaltitudeupdef}'\n"
   }

   # sunalt
   if {$numligne==$numligne_sunalt} {
      set sunaltdef [lindex $obj 1]
      Message console "${entete_ligne_console}$caption(explorer,sunalt) : '${sunaltdef}'\n"
   }

   # moonalt
   if {$numligne==$numligne_moonalt} {
      set moonaltdef [lindex $obj 1]
      Message console "${entete_ligne_console}$caption(explorer,moonalt) : '${moonaltdef}'\n"
   }

   # endpark
   if {$numligne==$numligne_endpark} {
      set endparkdef [lindex $obj 1]
      Message console "${entete_ligne_console}$caption(explorer,endpark) : '${endparkdef}'\n"
   }

   # autoguidephd
   if {$numligne==$numligne_autoguidephd} {
      set autoguidephddef [lindex $obj 1]
      Message console "${entete_ligne_console}$caption(explorer,autoguidephd) : '${autoguidephddef}'\n"
   }


   if {$numligne>=$numligne_coord1} {
      # On ne fait rien ici
   }
}

# Pointage et acquisition

for {set i 1} {$i<=$iterationdef} {incr i} {
   #waitbeforeserie (pas de wait before serie avant la premi?re s?rie)
   if {$i>1 & $waitbeforeseriedef!=0} {
      Message console "${entete_ligne_console}$caption(explorer,wait_before_serie) ${waitbeforeseriedef} $caption(explorer,seconds)...\n"
      after [expr $waitbeforeseriedef*1000]
   }

   Message console "${entete_ligne_console}------------------------------ $caption(explorer,serie) : ${i}\n"
   set numligne 0
   foreach obj $contents {
      set numligne [expr $numligne+1]

      if {$numligne>=$numligne_coord1} {
         if {[lindex $obj 0]!="*" && [lindex $obj 0]!="%" } {
            set rah [lindex $obj 0]
            set ram [lindex $obj 1]
            set decd [lindex $obj 2]
            set decm [lindex $obj 3]
            # Les champs suivants ne sont peut ?tre pas renseign?s (prise en compte des param?tres de l'en-t?te)
            set binningspec [lindex $obj 4]
            set timeexposurespec [lindex $obj 5]
            set numberexposurespec [lindex $obj 6]
            set headingnamespec [lindex $obj 7]
         } else {
            # Ligne pr?c?d?e d'un caract?re "*"
            set rah [lindex $obj 1]
            set ram [lindex $obj 2]
            set decd [lindex $obj 3]
            set decm [lindex $obj 4]
            # Les champs suivants ne sont peut ?tre pas renseign?s (prise en compte des param?tres de l'en-t?te)
            set binningspec [lindex $obj 5]
            set timeexposurespec [lindex $obj 6]
            set numberexposurespec [lindex $obj 7]
            set headingnamespec [lindex $obj 8]
         }

         set ra "${rah}h${ram}m"
         set dec "${decd}d${decm}m"

         if {[lindex $obj 0]=="%"} {
		set rah [expr $rah+180 ]
		if {$rah> 360 } {set rah [expr $rah-360 ]}
            set az "${rah}d${ram}m"
            set alt "${decd}d${decm}m"
	      set now [clock format [clock seconds] -gmt 1 -format "%Y %m %d %H %M %S"]
		set home $audace(posobs,observateur,gps)
            set res [mc_altaz2radec $az $alt $home $now]
            set ra  [format "%5.2f" [lindex $res 0]]
            set dec [format "%5.2f" [lindex $res 1]]
		set ra [expr $ra /15]
		set rah [expr int($ra) ]
		set ram [expr 60*($ra-$rah) ]
		set decd [expr int($dec) ]
		set decm [expr 60*($dec-$decd) ]
            set ra "${rah}h${ram}m"
            set dec "${decd}d${decm}m"
		}

         if {($binningspec!="") & ($timeexposurespec!="") & ($numberexposurespec!="") & ($headingnamespec!="")} {
            # On prend les param?tres sp?cifiques ? la ligne
            set binning $binningspec;
            set timeexposure $timeexposurespec;
            set numberexposure $numberexposurespec;
            set headingname $headingnamespec;
         } else {
            # On prend les param?tres de la ligne
            set binning $binningdef;
            set timeexposure $timeexposuredef;
            set numberexposure $numberexposuredef;
            set headingname $headingnamedef;
         }

         # Pour ne pas tenir compte des lignes vides
         if {$rah!=""} {
            if { $audace(telNo) == "0" } {
##               set base [ ::confVisu::getBase 1 ]
##               ::confTel::run
##               tkwait window $base.confTel
            }
		set now [clock format [clock seconds] -gmt 1 -format "%Y %m %d %H %M %S"]
		set home $audace(posobs,observateur,gps)
            set res [mc_radec2altaz $ra $dec $home $now]
            set az  [format "%5.2f" [lindex $res 0]]
            set alt [format "%5.2f" [lindex $res 1]]		
		set az [expr $az+180 ]
		if {$az> 360 } {set az [expr $az-360 ]}
		set objobs 0
	
		if { $limitazimuthleftdef<=$limitazimuthrightdef && $az>$limitazimuthleftdef && $az<$limitazimuthrightdef} {set objobs 1}
		if { $limitazimuthleftdef>$limitazimuthrightdef && $az<$limitazimuthleftdef } {set objobs 1}
            if { $limitazimuthleftdef>$limitazimuthrightdef && $az>$limitazimuthrightdef } {set objobs 1}
		if { $limitaltitudeupdef<$alt } {set objobs 0}
		if { $limitaltitudedowndef>$alt } {set objobs 0}
            if {$objobs==0} {Message console "${entete_ligne_console} Not $caption(explorer,goto_position) : ${ra} ${dec}, Az=${az} alt=${alt} Object not visible \n" }
		set jd_deb [mc_date2jd $now]
		set jj [expr $jd_deb]
		set sunbelowgor [lindex [mc_ephem {sun} [list [mc_date2tt $jj ]] {ALTITUDE } -topo $home] 0]
		set moonbelowgor [lindex [mc_ephem {moon} [list [mc_date2tt $jj ]] {ALTITUDE } -topo $home] 0]
		Message console "SunAlt= ${sunbelowgor} MoonAlt= ${moonbelowgor}  \n"
		set dsun [expr $sunbelowgor - $sunaltdef]
		set dmoon [expr $moonbelowgor - $moonaltdef]
		if {$dsun> 0 } {Message console "Sun altitude: ${sunbelowgor} >${sunaltdef}. script end  \n"}
		if {$dsun> 0 } {set objobs 0; set i [expr $iterationdef + 1 ]; break }
		if {$dmoon> 0 } {Message console "Moon altitude: ${moonbelowgor} >${moonaltdef}. script end  \n"}
		if {$dmoon> 0 } {set objobs 0; set i [expr $iterationdef + 1 ]; break }
            if {$objobs!=0} {
            Message console "${entete_ligne_console}$caption(explorer,goto_position) : ${ra} ${dec}, Az=${az} alt=${alt} ($caption(explorer,serie) ${i})\n"
            tel$audace(telNo) radec goto [list $ra $dec] -blocking 1 -equinox J2000.0
            # La ligne n'est pas pr?c?d?e d'un caract?re "*", on lance les acquisitions
            if {[lindex $obj 0]!="*"} {
               for {set j 1} {$j<=$numberexposure} {incr j} {
                  if {$waitbeforeexposuredef!=0} {
                     Message console "${entete_ligne_console}$caption(explorer,wait_before_exposure) ${waitbeforeexposuredef} $caption(explorer,seconds)...\n"
                     after [expr $waitbeforeexposuredef*1000]
                  }
                  if { $audace(camNo) == "0" } {
                     ##set base [ ::confVisu::getBase 1 ]
                     ##::confCam::run
                     ##tkwait window $base.confCam
                  }
                  Message console "${entete_ligne_console}$caption(explorer,acq_position) : ${ra} ${dec} ($caption(explorer,serie) ${i}) ($caption(explorer,number) ${j})\n"
			set now [clock format [clock seconds] -gmt 1 -format "%Y %m %d %H %M %S"]
 			set jd_deb [mc_date2jd $now]
			set jj [expr $jd_deb]
			set sunbelowgor [lindex [mc_ephem {sun} [list [mc_date2tt $jj ]] {ALTITUDE } -topo $home] 0]
  		      set moonbelowgor [lindex [mc_ephem {moon} [list [mc_date2tt $jj ]] {ALTITUDE } -topo $home] 0]
		      set dsun [expr $sunbelowgor - $sunaltdef]
  		      set dmoon [expr $moonbelowgor - $moonaltdef]
  		      if {$dsun> 0 } {Message console "Sun altitude: ${sunbelowgor} >${sunaltdef}. script end  \n"}
			if {$dsun> 0 } {set objobs 0; set j [expr $numberexposure + 1 ]; set i [expr $iterationdef + 1 ];	break }
		      if {$dmoon> 0 } {Message console "Moon altitude: ${moonbelowgor} >${moonaltdef}. script end  \n"}
			if {$dmoon> 0 } {set objobs 0; set j [expr $numberexposure + 1 ]; set i [expr $iterationdef + 1 ];	break }

			if { $objobs!=0 } {
				if {$autoguidephddef== "yes" }  { 
					exec phdguid.exe 1
					after 3000 
                              }
				acq $timeexposure $binning
				if {$autoguidephddef== "yes" } {exec phdguid.exe 2 }
                  }
                  if {[string index $decd 0]=="+"} {set hemisphere "N"} else {set hemisphere "S"}
                  set dizaine_decd [string index $decd 1]
                  set unite_decd [string index $decd 2]
			set rah [expr int($rah) ]
			set ram [expr int($ram) ]
			set decm [expr int($decm) ]
                  set nomfichier "${headingname}_${rah}${ram}_${hemisphere}${dizaine_decd}${unite_decd}${decm}_${i}_${j}"
                  Message console "${entete_ligne_console}$caption(explorer,save_image_file) : ${nomfichier}\n"
                  saveima $nomfichier
               }
            }
            }
         }
      }
   }
}

if {$endparkdef== "yes" } {
   set ra 0
   set dec 90
   tel$audace(telNo) radec goto [list $ra $dec] -blocking 1 -equinox J2000.0
   Message console "Telescope Park \n"
}   
# That's all !
Message console "${entete_ligne_console}$caption(explorer,explorer_complete)\n"

